function P = perimeter_from_chain_code(cc, method)
   

  num_odd = 0;
  num_corners = 0; % Number of occurances of unequal consecutive chain elements

  for i = 1:length(cc)
    num_odd = num_odd + mod(cc(i), 2);
  end
  num_even = length(cc) - num_odd;

  for i = 1:length(cc)
    if i > 1
      if cc(i) ~= cc(i-1)
        num_corners = num_corners + 1;
      end
    end
  end

  if strcmp(method,'Freeman')
    P = num_even + sqrt(2)*num_odd;
  end
  if strcmp(method,'Vossepoel')
    P = 0.980*num_even + 1.406*num_odd - 0.091*num_corners;
  end
  if strcmp(method,'Kulpa')
    P = pi/8 * (1 + sqrt(2)) * (num_even + sqrt(2)*num_odd);
  end

end